function [row, col] = randomMoves(~, board, ~)
    % Randomly pick an empty spot (not a valid competition strategy)
    [emptyRow, emptyCol] = find(board == 0);
    idx = randi(length(emptyRow));
    row = emptyRow(idx);
    col = emptyCol(idx);
end