function victoriousPlayer = ticTacToe(player1FHandle, player2FHandle)
    N = 3; % FOR DEBUGGING YOU CAN CHANGE THIS, BUT THE COMPETITION WILL RUN WITH THESE VALUES N = 30
    minToWin = 3; % FOR DEBUGGING YOU CAN CHANGE THIS, BUT THE COMPETITION WILL RUN WITH THESE VALUES minToWin = 5
    % Initialize the game board as a 3x3 matrix of zeros
    board =  zeros(N);
    turn = 0;
    % Player 1 is '1' (X), Player 2 is '2' (O)
    currentPlayer = randi(2);
    % Main game loop
    while all(board, 'all') ~= true
        % Display the current board state
        dispBoard(board, 0.2);
        % Get the current player's move
        % This function should return the row and column where the player wants to make their move.
        %[row, col] = randomMoves(currentPlayer, board);
        if currentPlayer == 1
            [row, col] = player1FHandle(currentPlayer,board, minToWin);
        else
            [row, col] = player2FHandle(currentPlayer,board, minToWin);
        end
        
        % Place the player's move on the board
        board(row, col) = currentPlayer;
        % Inside the main game loop, after a move is made
        % Check for a winner
        if checkWin(board, minToWin)
            disp(['Player ', num2str(currentPlayer), ' wins!']);
            disp(['Turn: ', num2str(turn)])
            victoriousPlayer = currentPlayer;
            dispBoard(board, 0);
            return;
        end
        
        % Switch players
        currentPlayer = 3 - currentPlayer;
        turn = turn + 1;
    end
    disp(['Turn: ', num2str(turn)])
    disp('The game is a draw.');
    victoriousPlayer = 0;
end
